#/bin/bash

export RPC_URL=http://127.0.0.1:8332
export RPC_USER=replace
export RPC_PASS=replace
SHELL_PATH=$(pwd -P)
export DEBUGGING="False"

#----- Miners in server mode can use external CPU-ECM and CUDA-ECM using the following settings.
#export CPUECM_SERVER_IP="192.168.0.11 192.168.0.12 192.168.0.13"
#export CPUECM_SERVER_PORT="19301 19301 19301"
#export CUDAECM_SERVER_IP="127.0.0.1"
#export CUDAECM_MAX_LEVEL=4
#######################################################################

#----- Miners in client (slave) mode must set the address of the master.#####
export MINER_MODE="SERVER CLIENT" #Default SERVER  ["SERVER" "CLIENT"]
export CADO_SERVER_URL="http://127.0.0.1:24242"
export CADO_CLIENT_BASE_PATH="/tmp"  #Default /tmp
#-----  The message server is set to CADO_SERVER_URL by default.
#export MSG_SERVER_IP="192.168.0.12"
#export MSG_SERVER_PORT=29291
#----- When you want dual mining in Slave..
#export DUAL_MINING_CHECK_PROCESS="yafu qli-Client qli-runner xmrig"
########################################################################

####### The level allowed value of the integer filtered by CUDA-ECM when the miner in server mode enters the first, second and next cado-nfs
export FIRST_ACCEPT_LEVEL=4 #Default 4
export SECOND_ACCEPT_LEVEL=4 #Default 4
export THIRD_ACCEPT_LEVEL=4 #Default 4
########################################################################

####### This is the address of the central server for collecting logs. However, it is temporarily used as a plan to collect from Apache Kafka in the future.
export CENTRAL_MN_IP="127.0.0.1"
export CENTRAL_MN_PORT=19201
########################################################################

####### This is a setup for using Apache Kafka Broker.##################
#export MN_BROKER="127.0.0.1:9092"
#export FARM_GROUP="FARM"
#export MINER_GROUP="GRP01"
#export WORKER=$HOSTNAME
########################################################################

####### This is a setup for msieve #####################################
#export USE_MSIEVE="True"
#----- Use one of the two. The first can be used stably, but filtering is repeatedly performed. Second, high performance can be obtained by adjusting tasks.sieve.rels_wanted among CADO-NFS parameters..
#----- stable but late
#export SENTENCE_IN_CADO_NFS_FOR_STOPPING_PROCESS="Info:Filtering - Merging: Starting"
#----- It is fast, however, the value of parameter "tasks.sieve.rels_wanted" in cado-nfs must be carefully adjusted.
#export SENTENCE_IN_CADO_NFS_FOR_STOPPING_PROCESS="Info:Complete Factorization / Discrete logarithm: Lattice Sieving"
#----- This is a setup where the msieve process can work as a background.
#export USE_DUAL_PROCESS="True"
########################################################################

####### Rarely used options ############################################
#export W_MUL_INTERVAL=8
#export SORT_SEED="False"
#export ECM_ONLY="False"
#export YAFU_ONLY="False"
#export CADO_CLIENT_THREAD_COUNT=2
#export STOP_CADO_PROCESS_WITH_DUAL="True"
########################################################################


cd $SHELL_PATH
cd bin
cpu_cores=$(lscpu | grep '^CPU(s):' | awk '{print $2}')
echo "cpu core : $cpu_cores"
softSMTon=$(cat /sys/devices/system/cpu/smt/control)
echo "SMT on/off : $softSMTon"
if [ "$softSMTon" = "off" ]; then
  cpu_cores=$(( cpu_cores / 2 ))
fi
echo "thread : $cpu_cores"

while :
do
./miner $cpu_cores 0 ValidScriptPubKey
sleep 5
done
